unit smallhelpers;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, tmex_support, dialogs;
//(Dialogs for the ACCEPTABLE showmessage inclued below about bad params.

procedure DoReports(bCallType:byte;siErr:smallint;sRoutine,sLoc:string);
function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
function sFixedWidth(bLength:byte;cPad:char;sTmp:string):string;
function sBarGraph(singLo,singHi:single;bLength:byte;singShow:single):string;

implementation

uses ldn031u1;//(To give access to array siaRom, etc)

var sTmp:string;

function sBarGraph(singLo,singHi:single;bLength:byte;singShow:single):string;
//(NOTE TO SELF... MAKE A TUT OF THIS!)

//Will only produse satisfactory results if....
//The two characters used (I used a '*' and a space) take
//   the same horizontal space, ** OR **
//The font of the component where the result is displayed
//   is not proportionally spaced. E.g. Courier is okay.


//(SR is crude at the moment and neither it, nor what's below,
//   guaranteed to do EXACTLY what's promised!... Well... that
//   was my attitude when I started writing this TINY, TRIVIAL
//   routine 90 minutes ago. It OUGHT to work correctly, fully,
//   given the time I've spent on it!!! Argh. 23 Aug 16


//When fully finished, this function will return a string of spaces
//and *'s showing wShow as a bar graph. It will be bLength characters
//singLo will set the lowest value, one that will show all spaces.
//singHi will set the upper value, the one that shows all *s
//Values above or below singLo/ singHi will be clipped to that range.
//So... for bLength=6, singLo=100, singHi=200, here's what you'd see,
//for different values of wShow...

//50: (all spaces)
//100: '       ' (all spaces)
//120: '*      '
//150: '***    '
//190: '****** '
//200: '*******'
//250: '*******'

//-------------------------
//If you want to do something like this, but using only integer-type
//variables, it will work okay as long as you have a LARGE range from
//singLo to singHi, relative to your bLength value. For instance,
//singLo=1500, singHi=3300 and bLength=32 would probably be fine.
//If, say, you were plotting ttures, and you had had the tture in
//degrees C (about 15-33 would be "cool room" to "sensor on tongue"),
//just multiply up the value from Celsius degrees to Celcius centi-
//degrees before passing "the value" (to be graphed) to the graphing
//routine.

var singDiff,singStep,singAcc:single;
  sTmp:string;

begin
if singHi<=singLo then showmessage('Bad params passed to sBarGraph. '+
    'Fix the hard coded error');
if singShow>singHi then singShow:=singHi;
if singShow<singLo then singShow:=singLo;
singDiff:=singHi-singLo;
singStep:=singDiff/bLength;
sTmp:='';
singAcc:=singLo+singStep;
while ((length(sTmp)<bLength)
   and (singShow>singAcc)) do begin

  sTmp:=sTmp+'*';
  singAcc:=singAcc+singStep;
  end;//while

//Now add spaces at the end, in case something else is
//  going on the same line as the bar graph...

while length(sTmp)<=bLength do sTmp:=sTmp+' ';

result:=sTmp;
end;

function sFixedWidth(bLength:byte;cPad:char;sTmp:string):string;
begin
while length(sTmp)<bLength do sTmp:=cPad+sTmp;
result:=sTmp;
end;

procedure DoReports(bCallType:byte;siErr:smallint;sRoutine,sLoc:string);
begin
sTmp:=ReportErr(bCallType,siErr,sRoutine,sLoc);
//Params: group code, error code from TMEX, what routine, where in code.
ldn031f1.meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
end;//DoReports

function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
//bCallType: A TKB allocated code... see sErrCodeToStr
//siErr: The error code returned from a TMEX call
//sRoutine: The name of the routine that returned the error, e.g. TMTouchByte
//   (What this can be restricted by bCallType, but several routines can
//    share one bCallType)
//sLoc: A unique string to ID where the call was in the code, so de-bugging
//   can be done.

//Inserts a verbose string into a memo.
//Returns a concise string which typically would be passed to a log file.
begin
ldn031f1.meMsgs.lines.insert(0,'Err seen at ((time)) when '+sRoutine+
   ' called: '+sErrCodeToStr(bCallType,siErr)+
   '. Prgm was at "'+sLoc+'"');
result:='((time)) In code at:'+sLoc+' saw err '+inttostr(siErr)+
   ' on call '+sRoutine;
end;//ReportErr

end.

