unit tmex_support;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, iBTMEXPW;
  //Is having to repeat iBTMEXPW here a problem? (Without it, compiler
  //says it hasn't heard of TMTouchByte, etc., so would like to leave.)

const kTmexSupportUnitVers='22 Aug 16';

//See http://sheepdogguides.com/lut/lt4Nb.htm for
//  help with putting things into support units.
type
  TudrTmp_Test = record
     sFrmTest:string;
     bFrmTest:byte;
     end;//definition of type

type
  TudrTryTmex0 = record
     boFail:boolean;//Returns true if call failed
     siResult:smallint;//Returns error code, if error arose, or
             //byte from MicroLan if it was READIMG, and no
             //error arose. Note: All but LS 8 bits stripped in
             //the "no error" case.
     end;//definition of type

function udrTmp_TestTryUDR:TudrTmp_Test;
function sVerTmex_Support:string;
function TB_TmpTrial:string;
//function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
function sErrCodeToStr(bCallType:byte;siErrCode:smallint):string;
function udrTryTMTouchByteRead:TudrTryTmex0;
procedure FillSiaRom(bWhichChip:byte);


implementation

uses ldn031u1;//This a "back up the line" uses, has to be here, not higher.
//N.B.: **U1* here... the unit, and *F1* below, when specing components of
//         the form IN the unit

//------------------------------------------
function sVerTmex_Support:string;
begin
result:=kTmexSupportUnitVers;
end;

procedure FillSiaRom(bWhichChip:byte);
var bCount:byte;
//NB: "Family code" goes in siNumbersForTMRom[0], and rest fill with
//  the parts of the ID code from family code end to other end.
//I.e. if the family code were 28, and the chip ID were...
//  1122334455667728, then  siNumbersForTMRom[0],[1],[2], etc would be..
//  28, 77, 66, 55, 44, 33... etc, with 11 going in siNumbersForTMRom[7]

//What subroutine does...
//    siaRom[0]:=strtoint('$'+copy(sChipID[bTmp],15,2));
//    siaRom[1]:=strtoint('$'+copy(sChipID[bTmp],13,2));
//    ...
//    siaRom[7]:=strtoint('$'+copy(sChipID[bTmp],1,2));

begin
for bCount:=0 to 7 do begin
   ldn031f1.siaROM[7-bCount]:=strtoint('$'+
            copy(ldn031f1.sChipID[bWhichChip],(bCount*2)+1,2));
   //showmessage(inttostr(strtoint('$'+
   //copy(ldn031f1.sChipID[bWhichChip],(bCount*2)+
   //  1,2))));// <<for testing. (Add "Dialogs" to units Uses clause to use
   //showmessage.
   end;//for
end;//FillSiaRom

function udrTryTMTouchByteRead:TudrTryTmex0;
//This function tries to do a TMTouchByte READ-FROM-MICROLAN
//(TMTouchByte with 2nd param = $FF. TMTouchByte can
//    also be used to WRITE a byte... but not via this SR!

//Returns result, incl messages about any error that arises.

//N.B: THE GLOBAL VARIABLE "liSessHdl" is accessed directly from
//within the subroutine. BAD PRACTICE, but I had my reasons,
//and the "error" is easily removed, if someone wants to be
//fussy. (Just add another parameter to the calling.)

//Yes: Second param is a smallint, even though it is for a byte.
//This to "be faithful" to what it shows in the TMEX API Help.

var siTmpL:smallint;
  boTmpL:boolean;//boFail will be filled from this
begin
boTmpL:=true;//init saying "call failed"
siTmpL:=TMTouchByte(ldn031f1.liSessHdl,$FF);
if siTmpL>=0 then boTmpL:=false;//do this if call SUCCESSFUL
//VERY DUBIOUS... SHOULD THE NEXT BE REMMED OUT???
//TMEX API help tells us that a return of $FF means MicroLan shorted...
//... but what if the DATA is $FF? How is that to be sent/ distinguished
//... from a "LAN SHORTED" condition??
//if siTmpL=255 then boTmpL:=true;//oops... NOT successful, after all.
if boTmpL=false then siTmpL:=siTmpL and $FF;
result.boFail:=boTmpL;
result.siResult:=siTmpL;//Either holds error code or LS 8 bits of
  //word read from chip.
end;//udrTryTMTouchByte

(* OLD STUFF SCRAPS.....
function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
//bCallType: A TKB allocated code... see sErrCodeToStr
//siErr: The error code returned from a TMEX call
//sRoutine: The name of the routine that returned the error, e.g. TMTouchByte
//   (What this can be restricted by bCallType, but several routines can
//    share one bCallType)
//sLoc: A unique string to ID where the call was in the code, so de-bugging
//   can be done.

//Inserts a verbose string into a memo.
//Returns a concise string which typically would be passed to a log file.
begin
ldn031f1.meMsgs.lines.insert(0,'Err seen at ((time)) when '+sRoutine+
   ' called: '+sErrCodeToStr(bCallType,siErr)+
   '. Prgm was at "'+sLoc+'"');
result:='((time)) In code at:'+sLoc+' saw err '+inttostr(siErr)+
   ' on call '+sRoutine;
end;//ReportErr
*)

function sErrCodeToStr(bCallType:byte;siErrCode:smallint):string;
//Turn a code for CallType and a TMEX error code into a string.

//The CallType parameter has values defined by what you find in this
//  subroutine. It allows multiple TMEX calls to share bits of this
//  code... only such calls as have identical Error Codes. The numbers
//  assigned to such "call groups" is arbitrary, and chosen by TKB
//The ErrCode is the one returned by the TMEX routine.

//Strings returned should be sentences, but have no terminal full stop.
var sResult:string;
begin
case bCallType of
0:begin//Use this for TMTouchByte
  //... possibly any that use 'TMEX Hardware Specific Error Return Codes'
   case siErrCode of
   255: sResult:='MicroLan shorted at time of reading';
    -1: sResult:='Specified MicroLan has not been initialized with a '+
          'call to the TMSetup function';
    -2: sResult:='Specified MicroLan nonexistent';
    -3: sResult:='Function not supported';
   -12: sResult:='Failure to communicate with hardware adapter';
   -13: sResult:='An unsolicited event occurred on the 1-Wire';
  -200: sResult:='Session not valid (not applicable in DOS TMEX)';
  -201: sResult:='Hardware_Specific driver not found and is required';

   else sResult:='Unexpected code passed to sErrCodeToStr for bCallType 0';
   end;//of case siErrCode
  end;//handle case '0'

99:begin
  end;//even LAST "then" before "else" SHOULD have ; in Case structure
else sResult:='SeeSErrCodeToStr:ACaseNotProvidedFor.ItIsCaseOf:'+
   inttostr(bCallType);
end;//case
result:=sResult;
end;//sErrCodeToStr

function udrTmp_TestTryUDR:TudrTmp_Test;
begin
 result.sFrmTest:='xx';
end;

function TB_TmpTrial:string;
begin
result:='trial of a put-in-sub-unit touchbyte';
end;


end.

