unit TtureConversions;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils{, Dialogs};
//For "finished product", REM OUT ALL SHOWMESSAGES...
//    When that's done, you should be able to rem out Dialogs from "Uses".
//(Will have to reinstate to use showmessages again when doing de-bugging)

function sTtureCfrmCentiK(wTture:word):string;//A "helper" function... see
    //comments at the head of its code.
function wRawTTureToCentiK(
     bTtureLo,bTtureHi,bChipFam:byte):word;

implementation

function sTtureCfrmCentiK(wTture:word):string;
//A "helper" function... about presenting values from
//  the Dallas chip in a human-friendly form.

//Supplied with tture in centidegrees Kelvin,
//Returns a string with that tture in Celcius
//

//This could be written better! But it works!

var sTmpL,sTmpL1:string;

begin
if wTture<27315 then begin //Process something that will be a negative
  wTture:=27315-wTture;
  sTmpL:=inttostr(wTture);
  if length(sTmpL)<2 then sTmpL:='0'+sTmpL;
  sTmpL1:=copy(sTmpL,1,length(sTmpL)-2)+'.'+copy(sTmpL,length(sTmpL)-1,2);
  if sTmpL1[1]='.' then sTmpL1:='0'+sTmpL1;
  sTmpL1:='-'+sTmpL1;
  end//no ; here. Negative number dealt with
 else begin
  wTture:=wTture-27315;
  sTmpL:=inttostr(wTture);
  if length(sTmpL)<2 then sTmpL:='0'+sTmpL;
  sTmpL1:=copy(sTmpL,1,length(sTmpL)-2)+'.'+copy(sTmpL,length(sTmpL)-1,2);
  if sTmpL1[1]='.' then sTmpL1:='0'+sTmpL1;
  end;//deal with tture at or above 0 deg C
result:=sTmpL1;
end;//sTtureCfrmCentiK

//=========================================================
function wRawTTureToCentiK(
     bTtureLo,bTtureHi,bChipFam:byte):word;
//A long and tedious "helper" function...
//  for converting the values from the Dallas chip
//  to a human-friendly form. This is "the easy bit",
//  which is a "minor detail" you need to attend to
//  AFTER "the hard bit". The hard bit is getting the
//  chip to TAKE a reading, and then tell you, in
//  its own arcane way, what the tture is.

var wTmpL:word;
    bHths:byte;
    boNegativeL:boolean;
    liTmpL:longint;//signed 32 bit

//"ERROR CODES"....
//Returns 65535	if there's a general problem.
//Returns 65534 iof it was sent a chip family it doesn't
//   know how to process.

//Otherwise returns the temperature indicted by the numbers
//  from the sensor... expressed in hundreTHs of degrees Kelvin.

//This routine looks arcane... and it may have errors in it!
//However, it is "no big deal".
//All we are doing here is taking the two numbers returned by
//  a Dallas 1-Wire tture sensor, and TRYING to apply the right
//  rules to convert them to a single number, closely related
//  to units used in the everyday world for measuring temperatures.

//In: two numbers, and a chip family ID
//Out: Temperature, in centiKelvins.
//Centi-Kelvin: hundreTH of a Kelvin degree.
//Zero Celcius is 273.15 Kelvin is 27315 centiKelvins
//100  Celcius is 373.15 Kelvin is 37312 centiKelvins

//THIS CODE HAS NOT BEEN TESTED AS THOROUGHLY as the rest of this
//I (and others!) have had trouble with the code for
//this conversion in the past, with, in particular, problems
//converting values which should give negative ttures in C, and
//other special cases.

//All of the 1-Wire tture sensors work in Celsius. If you want
//Fahrenheit, you're best bet is to convert the raw bytes
//to C, and go to F from there*)

//Both the DS1820 and the DS18B20 will return 85degC if their
//tture register is read before the power-on reset value is changed.

begin
wTmpL:=65535;//Init with code for "general error/ fail"
if (bChipFam<>$10)and(bChipFam<>$28)then begin //1
  wTmpL:=65534;//This error code reserved for...
  //showmessage('wRawTTureToCentiK was sent a chip type it doesn''t know '+
  //'what to do with. Will return a value of 65535');
  end; //end of deal with family code not $10 and not $28

if bChipFam=$10 then begin
//Convert bTtureLo and bTtureHi from a DS1820 to tture in centiKelvins

//This code for handling the two bytes from a DS1820,
//LSB of chip ID: $10. Examples taken from Dallas docs...
//I hope correctly... If code doesn't give these results,
//it is more likely the code that is wrong.

//In the table, the two bytes the DS1820 returns have been
//concatenated to a single 16-bit number.

//$0001 is 0.5 degree C  (27365 centidegrees K)
//$0007 is 3.5 d C       (27665 centidegrees K)
//$FFFF is -0.5 d C      (27265 centidegrees K)

//This algorithm only interprets the tture to 0.5 degree C.
//See data sheet for how to get greater resolution.

  //bTtureHi:=$0;//for debug
  //bTtureLo:=$0;//for debug

//Start by finding tture in hundreTHs of degrees Celcius

  if (bTtureLo and 1)=1 then
    bHths:=50 else bHths:=0;
  if bTtureHi=$FF then begin (*negative tture*)
    bTtureLo:=(NOT bTtureLo)+1;
    liTmpL:=(((bTtureLo div 2)*100)+bHths)*-1;
    end //no ; here. Done doing negative number
  else begin //+ve tture
    liTmpL:=((bTtureLo div 2)*100)+bHths;
  end;(*else*)

  //At this point, liTmpL holds tture in centidegrees C
  //showmessage(inttostr(liTmpL)); //<<for debug

//Next part also used in code for DS18B20... should move to a function
//  either can call

  //Be sure we aren't headed for a tture of below
  //   absolute zero, which is 0 degrees K
  if liTmpL<-27315 then begin
    //do nothing if <-27315.. flow will fall through, with
    //wTmpL still set to rogue for "problem"
    end//no ; here
   else begin//liTmpL was >= -27315... good!
  //Convert to centidegrees C to centidegrees K... to avoid the need
  //for negative numbers... dealing in centidegrees spared us fractions
    liTmpL:=liTmpL+27315;
    end;//.. of the else for liTmpL was >= -27315

  //liTmpL:=1000;//1000 centiK= 10 deg K:= -263.15 deg C<<for debug

  wTmpL:=liTmpL;
end;//bChipFam=$10

if bChipFam=$28 then begin
//Convert bTtureLo and bTtureHi from a DS18B20 to tture in centiKelvins

//This code for handling the two bytes from a DS18B20,
//LSB of chip ID: $28. Examples taken from Dallas docs...
//I hope correctly... If code doesn't give these results,
//it is more likely the code that is wrong.

//In the table, the two bytes the DS18B20 returns have been
//concatenated to a single 16-bit number.

//$07D0 is 125.00 degrees C
//$0008 is   0.5  degree C  (27365 centidegrees K)
//$0000 is   0.000 d C      (27315 centidegrees K)
//$FFF8 is - 0.500 d C      (27265 centidegrees K)
//$FF5E is -10.125 d C
//$FC90 is -55.000 dC

//if (bTtureHi and $F8) = $F8, the number is a negative number,
//  given in two's complement form.

//The LS 4 bits give the fractional part of the tture.

//The theoretical resolution of the hardware is 1/16th degree, but
//  this algorithm doesn't provide for thousandths of degrees

  //bTtureHi:=$0;//for debug
  //bTtureLo:=$0;//for debug



//Start by finding tture in hundreTHs of degrees Celcius

//Combine MS and LS bytes in wTmpL, remembering that at
//  the end of the SR that must be 65535 if conversion has failed, something
//  else if conversion has not failed.
//Decide if the number is +ve or negative, and use if.. then.. to temporarily
//  divide flow accordingly at this point after setting boNegativeL

//For +ve number... nothing to do at this stage
//For -ve number... do two's complement

//Calculate the centidegrees Celcius, forgetting whether number had 2's complement
//Move into liTmpL (signed) and multiply by -1 if boNegativeL is true.

//Now that tture in centidegrees C is in liTmpL, convert to centidegrees K,
//  and return that to wTmpL... or, as I said at start, make it 65535
//  if conversion has failed.

wTmpL:=bTtureHi*$FF+bTtureLo;

boNegativeL:=false;
if (wTmpL and $F800)=$F800 then begin
  boNegativeL:=true;
  wTmpL:=(NOT wTmpL)+1;
  end;

//Yes... this could be done better!
bTtureLo:=wTmpL AND $0F;//re-purposed to hold fraction part.
if bTtureLo=$0 then bHths:=0;//Exactly 0
if bTtureLo=$1 then bHths:=6;//
if bTtureLo=$2 then bHths:=12;//0.125
if bTtureLo=$3 then bHths:=18;//
if bTtureLo=$4 then bHths:=25;//Exactly 0.25
if bTtureLo=$5 then bHths:=32;//
if bTtureLo=$6 then bHths:=38;//0.375
if bTtureLo=$7 then bHths:=44;//
if bTtureLo=$8 then bHths:=50;//Exactly 0.5
if bTtureLo=$9 then bHths:=56;//
if bTtureLo=$10 then bHths:=62;//0.625
if bTtureLo=$11 then bHths:=68;//
if bTtureLo=$12 then bHths:=75;//Exactly 0.75
if bTtureLo=$13 then bHths:=82;//
if bTtureLo=$14 then bHths:=88;//0.875
if bTtureLo=$15 then bHths:=94;//

liTmpL:=wTmpL;//32 bit signed
liTmpL:=(liTmpL div 16)*100;//Integer part now in centidegrees C
liTmpL:=liTmpL+bHths;//add in the previously determined 100ths.
if boNegativeL then liTmpL:=litmpL*-1;//Fully realized tture in C centidegrees
//showmessage(inttostr(liTmpL));<<for prgm testing

//Next part also used in code for DS1820... should move to a function
//  either can call

  //Be sure we aren't headed for a tture of below
  //   absolute zero, which is 0 degrees K
  if liTmpL<-27315 then begin
    //do nothing if <-27315.. flow will fall through, with
    //wTmpL still set to rogue for "problem"
    end//no ; here
   else begin//liTmpL was >= -27315... good!
  //Convert to centidegrees C to centidegrees K... to avoid the need
  //for negative numbers... dealing in centidegrees spared us fractions
    liTmpL:=liTmpL+27315;
    end;//.. of the else for liTmpL was >= -27315

  //liTmpL:=1000;//1000 centiK= 10 deg K:= -263.15 deg C<<for debug

  wTmpL:=liTmpL;


//  wTmpL:=1100;//1100 centiK= 11 deg K:= -262.15 deg C
end;//bChipFam=$10

result:=wTmpL;//Tture in centiKelvins... or 65535 on error
end; //wRawTTureToCentiK

end.

